summaryrefslogtreecommitdiff
path: root/scripts/sh/poem
diff options
context:
space:
mode:
authorGeorge Abbott <george@gabbott.dev>2025-01-26 11:37:22 +0000
committerGeorge Abbott <george@gabbott.dev>2025-01-26 11:37:22 +0000
commit82abadcecc7534b4847238ee2a977f33256b0439 (patch)
treead8752c1dc9914829e80bc2f3f1a45dfec8f4b4a /scripts/sh/poem
parentbac748dbe8c28cf1ed3b387b24f89ffe5a58ffc9 (diff)
sh
Diffstat (limited to 'scripts/sh/poem')
-rwxr-xr-xscripts/sh/poem63
1 files changed, 63 insertions, 0 deletions
diff --git a/scripts/sh/poem b/scripts/sh/poem
new file mode 100755
index 0000000..9169f1a
--- /dev/null
+++ b/scripts/sh/poem
@@ -0,0 +1,63 @@
+#!/bin/sh
+# poem: write a poem
+
+begins_with() { # haystack prefix
+ value=$1
+ prefix=$2
+
+ case "$value" in
+ "$prefix"*) return 0
+ esac
+
+ return 1
+}
+
+usage() {
+ echo "poem [help | ls | ls-html | NAME]"
+}
+
+fuzzy() {
+ FILE="$(find "$WWW_DEFAULT_PATH/src/poetry" -type f | $FUZZY)"
+ [ -z "$FILE" ] && exit 0
+ if ! begins_with "$FILE" "$WWW_DEFAULT_PATH/src/poetry" ; then
+ FILE="$WWW_DEFAULT_PATH/src/poetry/$FILE"
+ fi
+
+ mkdir "$(dirname "$FILE")" -p
+ $EDITOR "$FILE"
+}
+
+list() {
+ header="Date\tTitle\n"
+ for f in $(find $WWW_DEFAULT_PATH/src/poetry -type f | sort -k 3) ; do
+ out="$out$(sed -n 2p $f)\t$(sed -n 1p $f)\n"
+ done
+ out="$header$(printf "$out" | sort -rk 1)\n"
+ printf "$out"
+}
+
+list_html() {
+ header="<table>\n<tr><th>Date</th>\t<th>Title</th></tr>\n"
+ for f in $(find $WWW_DEFAULT_PATH/src/poetry -type f | sort -k 3) ; do
+ out="$out\t<tr><td>$(sed -n 2p $f)</td><td><a href=\"/poetry/$(basename "$f")\">$(sed -n 1p $f)</a></td></tr>\n"
+ done
+ out="$header$(printf "$out" | sort -rk 1)\n</table>\n"
+ printf "$out"
+}
+
+
+[ -z "$WWW_DEFAULT_PATH" ] && echo "WWW_DEFAULT_PATH not set" && exit 1
+[ -z "$EDITOR" ] && echo "EDITOR not set" && exit
+[ -z "$FUZZY" ] && echo "FUZZY not set" && exit
+[ "$1" = "help" ] && usage && exit 0
+[ "$1" = "ls" ] && list && exit 0
+[ "$1" = "ls-html" ] && list_html && exit 0
+
+if [ -z "$1" ] || [ "$1" = "fuzzy" ] ;
+then
+ fuzzy
+ exit 0
+fi
+
+mkdir -p "$WWW_DEFAULT_PATH/src/poetry"
+$EDITOR "$WWW_DEFAULT_PATH/src/poetry/$1"